
--Locale
local L_CRIT = " ".. _G["CRIT_ABBR"]
local L_HIT = " ".. _G["HIT"]
local L_SPEED = " ".. _G["SPEED"]
local L_AP = " ".. _G["ATTACK_POWER_TOOLTIP"]
local L_HASTE = " ".. _G["STAT_HASTE"]

--Objects Creation
local RS = CreateFrame("Frame", "StatBlock_RangedStats")
local LDB = LibStub("LibDataBroker-1.1")
RS.AP = LDB:NewDataObject("Ranged_AP", {type = "data source", text = "0"..L_AP, value = "0", suffix = L_AP})
RS.Crit = LDB:NewDataObject("Ranged_Crit", {type = "data source", text = "0%"..L_CRIT, value = "0%", suffix = L_CRIT})
RS.Hit = LDB:NewDataObject("Ranged_Hit", {type = "data source", text = "0%"..L_HIT, value = "0%", suffix = L_HIT})
RS.Speed = LDB:NewDataObject("Ranged_Speed", {type = "data source", text = "0.00"..L_SPEED, value = "0.00", suffix = L_SPEED})
RS.Haste = LDB:NewDataObject("Ranged_Haste", {type = "data source", text = "0%"..L_HASTE, value = "0%", suffix = L_HASTE})
LDB = nil

-- Upvalues
local format = string.format
local UnitRangedAttackPower = UnitRangedAttackPower
local UnitRangedDamage = UnitRangedDamage
local GetCombatRatingBonus = GetCombatRatingBonus
local GetRangedCritChance = GetRangedCritChance
local GetHitModifier = GetHitModifier
local two_fp = "%.2f%%"

-- Combat Rating Constants
local CR_HIT_RANGED = CR_HIT_RANGED
local CR_HASTE_RANGED = CR_HASTE_RANGED

--Events
RS:RegisterEvent("UNIT_MODEL_CHANGED")
RS:RegisterEvent("PLAYER_LEVEL_UP")
RS:RegisterEvent("UNIT_AURA")
RS:RegisterEvent("PLAYER_LOGIN")

--Calculations
RS:SetScript("OnEvent", function(self, event, unit)
	if unit and unit ~= "player" then return end

	local base, pos, neg = UnitRangedAttackPower"player"
	local ap = format("%d", base + pos + neg)
	self.AP.text = ap..L_AP
	self.AP.value = ap

	local hit = format(two_fp, GetCombatRatingBonus(CR_HIT_RANGED)+GetHitModifier())
	self.Hit.text = hit..L_HIT
	self.Hit.value = hit

	local crit = format(two_fp, GetRangedCritChance())
	self.Crit.text = crit..L_CRIT
	self.Crit.value = crit

	local haste = format(two_fp, GetCombatRatingBonus(CR_HASTE_RANGED))
	self.Haste.text = haste..L_HASTE
	self.Haste.value = haste

	local speed = format("%.2f", UnitRangedDamage"player")
	self.Speed.text = speed..L_SPEED
	self.Speed.value = speed
end)

